/* eslint-disable prettier/prettier */
<template>
  <div>
    <v-container>
      <v-row no-gutters>
        <v-col>
          <v-card class="elevation-4">
            <v-toolbar flat color="white">
              <v-toolbar-title class="font-weight-bold primary--text">
                Material de Apoio
              </v-toolbar-title>
              <v-icon small class="mx-2">mdi-chevron-double-right</v-icon>
              <div class="navSupportResourceOption">
                <v-btn
                  v-if="
                    (hasMethod('readSupportResource') && createSupportResourceShow) ||
                    (hasMethod('readMySupportResource') && createSupportResourceShow)
                  "
                  small
                  color="primary"
                  class="mr-4"
                  elevation="0"
                  @click="openDialogFile()"
                >
                  Adicionar
                  <v-icon small right class="ml-3">mdi-plus</v-icon>
                </v-btn>
              </div>
              <v-spacer />
              <v-col cols="3">
                <v-text-field
                  v-model="search"
                  append-icon="mdi-magnify"
                  label="Pesquisar por..."
                  clearable
                  clear-icon="mdi-close-circle-outline"
                  class="searchStyle mt-5"
                  single-line
                />
              </v-col>
            </v-toolbar>
            <v-card-text class="mt-n2">
              <v-row justify="center" no-gutters>
                <v-col class="contentP">
                  <section
                    class="noResources"
                    v-if="supportResource.length == 0 && loading == false"
                  >
                    <v-icon class="pr-2 pb-2" x-large>mdi-alert</v-icon>
                    <p>
                      Ops, parece que essa entidade ainda <b>não possui nenhum</b> material de apoio
                      <b>:(</b>
                    </p>
                  </section>

                  <v-treeview
                    v-model="tree"
                    :open="open"
                    :search="search"
                    :items="supportResource"
                    item-key="id"
                    @update:open="openFolder($event)"
                  >
                    <!-- PREPEND -->
                    <template v-slot:prepend="{ item, open }">
                      <v-icon
                        :color="iconsColor[item.extension]"
                        v-if="item.file"
                        @click="download(item)"
                        >{{ item.icon }}</v-icon
                      >
                      <v-icon :color="iconsColor.link" v-if="item.link" @click="openLink(item)">{{
                        item.icon
                      }}</v-icon>
                      <v-icon
                        color="grey"
                        v-if="item.folder && open"
                        @click="clickToOpenFolder(item)"
                        >mdi-folder-open</v-icon
                      >
                      <v-icon
                        color="grey"
                        v-if="item.folder && !open"
                        @click="clickToOpenFolder(item)"
                        >mdi-folder</v-icon
                      >
                    </template>
                    <!-- LABEL -->
                    <template slot="label" slot-scope="{ item }">
                      <v-tooltip nudge-top="3" bottom color="primary">
                        <template v-slot:activator="{ on }">
                          <!-- link externo -->
                          <a
                            v-on="on"
                            v-if="item.externalLink"
                            :href="item.externalLink.link"
                            target="_blank"
                            style="text-decoration: none"
                          >
                            {{ item.name }}</a
                          >
                        </template>
                        <span>Ver Link Externo</span>
                      </v-tooltip>
                      <!-- diretório -->
                      <v-tooltip nudge-left="10" right color="transparent">
                        <template v-slot:activator="{ on }">
                          <span
                            v-on="on"
                            v-if="item.folder"
                            style="cursor: pointer"
                            @click="clickToOpenFolder(item)"
                          >
                            {{ item.name }}</span
                          >
                        </template>
                        <span style="font-size: 0.8rem" class="primary--text"
                          >(Clique para abrir)</span
                        >
                      </v-tooltip>
                      <!-- arquivo -->
                      <span v-if="item.file" style="cursor: pointer" @click="download(item)">
                        {{ item.name }}{{ item.file.extension }}</span
                      >
                      <!-- vazio -->
                      <span v-if="item.empty"> {{ item.name }}</span>
                    </template>
                    <!-- APPEND - ICONES AÇÕES -->
                    <template slot="append" slot-scope="{ item }">
                      <div class="supportIconsTable">
                        <v-tooltip nudge-top="3" bottom color="primary">
                          <template v-slot:activator="{ on }">
                            <v-btn
                              v-on="on"
                              v-if="item.externalLink"
                              :href="item.externalLink.link"
                              target="_blank"
                              icon
                              small
                            >
                              <v-icon small>mdi-link-variant</v-icon>
                            </v-btn>
                          </template>
                          <span>Ver Link Externo</span>
                        </v-tooltip>
                        <v-tooltip nudge-top="3" bottom color="primary">
                          <template v-slot:activator="{ on }">
                            <v-btn
                              v-on="on"
                              v-if="item.file && downloadSupportResourceShow"
                              icon
                              small
                              @click="download(item)"
                            >
                              <v-icon small>mdi-download</v-icon>
                            </v-btn>
                          </template>
                          <span>Download</span>
                        </v-tooltip>
                        <v-tooltip nudge-top="3" bottom color="primary">
                          <template v-slot:activator="{ on }">
                            <v-btn
                              v-on="on"
                              v-if="
                                (item.folder && createSupportResourceShow) ||
                                (item.folder && createSupportResourceShow)
                              "
                              icon
                              small
                              @click="openDialogChild(item)"
                            >
                              <v-icon small>mdi-folder-plus</v-icon>
                            </v-btn>
                          </template>
                          <span>Adicionar ao diretório</span>
                        </v-tooltip>
                        <v-tooltip nudge-top="3" bottom color="primary">
                          <template v-slot:activator="{ on }">
                            <v-btn
                              v-on="on"
                              v-if="editSupportResourceShow && !item.empty"
                              icon
                              small
                              @click="openDialogUpdate(item)"
                            >
                              <v-icon small>mdi-pencil</v-icon>
                            </v-btn>
                          </template>
                          <span>Editar</span>
                        </v-tooltip>
                        <v-tooltip nudge-top="3" bottom color="primary">
                          <template v-slot:activator="{ on }">
                            <v-btn
                              v-on="on"
                              v-if="removeSupportResourceShow && !item.empty"
                              icon
                              small
                              @click="openDialogDelete(item)"
                            >
                              <v-icon small>mdi-delete</v-icon>
                            </v-btn>
                          </template>
                          <span>Deletar</span>
                        </v-tooltip>
                      </div>
                    </template>
                  </v-treeview>
                </v-col>
              </v-row>
            </v-card-text>
          </v-card>
        </v-col>
      </v-row>
    </v-container>
    <v-dialog
      v-model="dialog"
      @keydown.esc="resetDialogInfo"
      @click:outside="resetDialogInfo"
      width="800px"
    >
      <AddSupportResource
        :title-dialog="titleDialog"
        :title-button="titleButton"
        :dialog="dialog"
        :item-folder="folderToEdit"
        :item-file="fileToEdit"
        :item-link="linkToEdit"
        :file-disable="fileDisable"
        :folder-disable="folderDisable"
        :child-disable="childDisable"
        :update="update"
        :daddy="daddy"
        :update-link="updateLink"
        :update-file="updateFile"
        :update-folder="updateFolder"
        @saveLink="saveLink"
        @saveFromDrive="saveFromDrive"
        @closeDialog="closeDialog"
        @saveFile="saveFile"
        @saveFolder="saveFolder"
        @editItem="editItem"
        @updateFileName="updateFileName"
        @addFileOnFolder="addFileOnDirectory"
        @addFilesOnFolder="addFilesOnDirectory"
        @addFileOnFolderSupportResource="addFileOnDirectory"
        @addFolderOnFolder="addFolderOnDirectory"
      />

      

    </v-dialog>
    <!-- Confirma deletar entidade -->
    <AlertConfirm
      :alert="alert"
      @clickCancelAlert="alert.status = false"
      @clickConfirmAlert="deleteItem"
    />
    <!-- <div>
      <delete
        :item-to-delete="itemToDelete"
        :dialog-delete="dialogDelete"
        @closeDelete="closeDialog"
        @confirmDelete="deleteItem"
      />
    </div> -->
  </div>
</template>

<script>
import { mapGetters, mapState } from 'vuex'
// import Delete from '../../components/supportMaterial/DeleteSupportResource'
import AddSupportResource from '../../components/supportMaterial/AddSupportResource'
import supportResource from '../../services/supportResource'
import SupportResource from '../../services/supportResource'

export default {
  name: 'SupportResource',
  components: {
    AddSupportResource,
  },
  props: {},
  data: () => ({
    loading: false,
    dialogDelete: false,
    updateLink: false,
    updateFolder: false,
    updateFile: false,
    update: false,
    tree: [],
    open: [],
    childDisable: false,
    titleButton: '',
    titleDialog: '',
    fileDisable: false,
    folderDisable: false,
    alert: {
      status: false,
      itemName: '',
      message: '',
      messageOk: 'Sim',
      messageCancel: 'Não',
    },
    itemToDelete: {},
    folderToEdit: null,
    fileToEdit: null,
    linkToEdit: { name: 'sssss', link: '' },
    search: null,
    supportResource: [],
    nextId: 1000,
    dialog: false,
    daddy: {},
    icons: {
      folder: 'mdi-folder',
      link: 'mdi-link-box-variant-outline',
      '.pdf': 'mdi-file-pdf-outline',
      '.PDF': 'mdi-file-pdf-outline',
      '.jpg': 'mdi-file-image-outline',
      '.xml': 'mdi-file-excel-outline',
      '.xls': 'mdi-file-excel-outline',
      '.pptx': 'mdi-file-powerpoint-outline',
      '.ppt': 'mdi-file-powerpoint-outline',
      '.png': 'mdi-file-image-outline',
    },
    iconsColor: {
      link: 'blue lighten-2',
      '.pdf': 'red lighten-2',
      '.PDF': 'red lighten-2',
      '.jpg': 'green lighten-2',
      '.xml': 'pink lighten-2',
      '.xls': 'brown lighten-2',
      '.pptx': 'purple lighten-2',
      '.ppt': 'purple lighten-2',
      '.png': 'green lighten-2',
    },
    downloadSupportResourceShow: false,
    removeSupportResourceShow: false,
    editSupportResourceShow: false,
    createSupportResourceShow: false,
    importFromDriveLenght: 0,
    progressImportFromDrive: 0,
    openedFolders: [],
    lastOpenedFolder: '',
    navParent: { id: '', name: '' },
    aleatorio: 0,
    temp: new Set(),
    tempChildren: [],
    lastClickInTree: '',
    clickToAddFolderOnDirectory: '',
  }),

  computed: {
    ...mapState({
      actionsMap: (state) => state.user.mappedActions,
      roles: (state) => state.user.rootEntities,
      methods: (state) => state.user.methods
    }),
    //vuex, retorna o id atual da entidade
    idEntity() {
      return this.$store.state.user.idActualEntity
    },
  },
  watch: {
    async idEntity() {
      // await this.init()
      this.createSupportResourceShow = false
      this.editSupportResourceShow = false
      this.removeSupportResourceShow = false
      this.downloadSupportResourceShow = false
      await this.checkPermissions()
    },
    async progressImportFromDrive() {
      if (this.progressImportFromDrive == this.importFromDriveLenght) {
        this.$store.commit('user/UPDATE_LOADING', false)
        await this.init()
        this.dialog = false
      }
    },
  },

  created() {
    this.checkPermissions()
    // await this.init()
  },
  methods: {
    ...mapGetters('user', ['HAS_METHOD']),
    openDialogLink() {
      this.dialogLink = true
    },

    //altera a informação dialog/ finalidade: resetar dados quando aperta esc no modal
    resetDialogInfo() {
      this.$store.commit('user/UPDATE_CLOSE_DIALOG', true)
    },

    async checkPermissions() {
      console.log('ao criar', this.actionsMap)
      if (this.actionsMap.get('supportResourceRead')) this.init()
      if (this.actionsMap.get('supportResourceCreate')) this.createSupportResourceShow = true
      if (this.actionsMap.get('supportResourceUpdate')) this.editSupportResourceShow = true
      if (this.actionsMap.get('supportResourceDelete')) this.removeSupportResourceShow = true
      if (this.actionsMap.get('supportResourceDownload')) this.downloadSupportResourceShow = true
    },
    async init() {
      this.lastClickInTree = ''
      this.open = []
      try {
        this.loading = true
        this.$store.commit('user/UPDATE_LOADING', true)
        const routedEntity = await this.$getItem('routedEntity'),
          actionId = this.actionsMap.get('supportResourceRead').id,
          ret = await SupportResource.readSupportResource(routedEntity.id, actionId)
        if (!ret.success) return console.error('Error', ret.data)
        // console.log(ret.data, 'dado original')
        // resultado do material de apoio
        this.supportResource = ret.data.map((resource) => {
          let icon = ''
          //se o obj da array possui .folder, ou seja, é um folder
          if (resource.folder) {
            icon = this.icons['folder']
            resource.children = []
            if (resource.folder.child) {
                if (resource.folder.child.folders) {
                    resource.folder.child.folders.forEach((folder) => {
                        resource.children.push({
                            ...folder,
                            icon: this.icons['folder'],
                            folder: [],
                        })
                    })
                }
              if (resource.folder.child.files) {
                    resource.folder.child.files.forEach((file) => {
                        resource.children.push({
                            ...file,
                            icon: this.icons[file.extension],
                            file: { extension: file.extension },
                        })
                    })
                }
              if (resource.folder.child.externalLinks) {
                    resource.folder.child.externalLinks.forEach((link) => {
                        resource.children.push({
                            ...link,
                            icon: this.icons.link,
                            link: link.link,
                            externalLink: link,
                        })
                    })
                }
            }
          }
          //se o obj da array possui .file, ou seja, é um file
          if (resource.file) icon = this.icons[resource.file.extension]

          //se o obj da array possui .externalLink, ou seja, é um link
          if (resource.externalLink) {
            icon = this.icons['link']
            console.log("opa", resource.externalLink)
            return {
              ...resource,
              icon: icon ? icon : 'mdi-file',
              link: resource.externalLink.link,
            }
          }

          return {
            ...resource,
            icon: icon ? icon : 'mdi-file',
          }
        })

        let organizeArray = []
        let folders = []
        let filesArray = []
        let links = []

        this.supportResource.forEach((item) => {
          if (item.file) filesArray.push(item)
          if (item.externalLink) links.push(item)
          if (item.folder) folders.push(item)
        })

        folders.sort(this.sortArrayMethod)
        filesArray.sort(this.sortArrayMethod)
        links.sort(this.sortArrayMethod)

        organizeArray = folders.concat(filesArray).concat(links)

        this.supportResource = organizeArray
      } catch (e) {
        console.error('Error', e)
      } finally {
        console.log(this.supportResource, 'Resposta requisição Material de Apoio')
        this.$store.commit('user/UPDATE_LOADING', false)
        this.loading = false
      }
    },
    sortArrayMethod(a, b) {
      if (a.name < b.name) return -1
      if (a.name > b.name) return 1
      return 0
    },
    openDialogChild(item) {
      console.log('TCL: openDialogChild -> item', item)
      this.daddy = item
      this.folderToEdit = {}
      this.fileToEdit = {}
      this.linkToEdit = { name: '', link: '' }
      this.childDisable = true
      this.titleButton = 'Adicionar'
      this.titleDialog = `Adicionar em '${this.daddy.name}'`
      this.dialog = true
    },
    openDialogFile() {
      this.daddy = {}
      this.titleButton = 'Adicionar '
      this.titleDialog = 'Adicionar Material de Apoio'
      this.childDisable = false
      this.folderToEdit = {}
      this.fileToEdit = {}
      this.linkToEdit = { name: '', link: '' }
      this.dialog = true
    },
    openDialogUpdate(item) {
      console.log('TCL: openDialogUpdate -> item', item)
      if (item.file) {
        this.fileToEdit = item
        this.updateFile = true
        this.titleDialog = 'Editar Arquivo'
      }
      if (item.folder) {
        this.folderToEdit = item
        this.updateFolder = true
        this.titleDialog = 'Editar Pasta'
      }
      if (item.externalLink) {
        this.linkToEdit = item
        this.updateLink = true
        this.titleDialog = 'Editar Link Externo'
      }
      this.titleButton = 'Editar'
      this.childDisable = false
      this.update = true

      this.dialog = true
    },
    openDialogDelete(item) {
      this.alert.itemName = item.name
      if (item.folder) this.alert.message = 'Você deseja <b>deletar</b> o diretório '
      if (item.externalLink) this.alert.message = 'Você deseja <b>deletar</b> o link externo '
      if (item.file) {
        this.alert.message = 'Você deseja <b>deletar</b> o arquivo '
        this.alert.itemName = item.name + item.file.extension
      }
      this.alert.status = true
      this.itemToDelete = item
    },
    closeDialog() {
      this.dialogDelete = false
      this.dialog = false
      this.updateLink = false
      this.updateFolder = false
      this.updateFile = false
      this.update = false
      this.childDisable = false
      this.titleButton = ''
      this.titleDialog = ''
      this.fileDisable = false
      this.folderDisable = false
      this.folderToEdit = null
      this.fileToEdit = null
      this.linkToEdit = { name: '', link: '' }
      this.daddy = {}
    },

    openFile(item) {
      console.log(item, 'Clicou p/ abrir esse arquivo')
    },

    async saveFile(supportResourceFile) {
      console.log('TCL: saveFile -> supportResourceFile', supportResourceFile)
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        const formData = new FormData()
        formData.append('localFile', supportResourceFile.file)
        const routedEntity = await this.$getItem('routedEntity'),
          actionId = this.actionsMap.get('supportResourceCreate').id,
          ret = await SupportResource.addLocalFile(
            routedEntity.id,
            actionId,
            supportResourceFile.file.name,
            supportResourceFile.name,
            formData
          )
        this.init()
        this.closeDialog()
        if (ret.success) {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: `O arquivo <b>${ret.data[0].name}</b> foi <b>enviado</b> com sucesso!`,
            icon: 'mdi-check-circle',
            color: 'green',
          })
        } else {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Erro! Não foi possível <b>adicionar</b> o arquivo.',
            icon: 'mdi-close-circle',
            color: 'red',
          })
        }
      } catch (Error) {
        console.log('TCL: saveFile -> Error', Error)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

  

    async addFolderOnDirectory(item) {
      console.log('criar pasta dentro de pasta', item)

      let idParent

      if (item.daddy.folder.id) idParent = item.daddy.folder.id
      else idParent = item.daddy.id

      let data = { parentId: idParent, folder: { name: item.supportResource.name } }
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        const routedEntity = await this.$getItem('routedEntity'),
          actionId = this.actionsMap.get('supportResourceCreate').id,
          ret = await SupportResource.addFolderOnFolder(routedEntity.id, actionId, data)
        if (ret.success) {
          this.init()
          this.refreshOpennedFolder({ id: idParent })
          this.dialog = false
          this.daddy = {}
          this.$store.commit('user/UPDATE_LOADING', true)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Nova pasta <b>adicionada</b> com sucesso ao diretório!',
            icon: 'mdi-check-circle',
            color: 'green',
          })

          // this.closeDialog()
        } else {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Desculpe não foi possível <b>adicionar</b> a nova pasta ao diretório!',
            icon: 'mdi-close-circle',
            color: 'red',
          })
        }
      } catch (Error) {
        console.log('TCL: saveFile -> Error', Error)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    async addFileOnDirectory(item) {
      console.log('tentando enviar esse arquivo dentro do diretório', item)
      console.log('frontend: addFileOnDirectory, porém está com bug backend')
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        const formData = new FormData()
        formData.append('localFile', item.file)
        const routedEntity = await this.$getItem('routedEntity'),
          actionId = this.actionsMap.get('supportResourceCreate').id,
          ret = await SupportResource.addFilesOnFolder(
            routedEntity.id,
            actionId,
            item.file.name,
            item.daddy.id,
            formData
          )
        console.log('addFileOnDirectory ->  ret ', ret)
        if (ret.success) {
          this.init()
          this.dialog = false
          this.daddy = {}
          this.$store.commit('user/UPDATE_LOADING', true)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Arquivo <b>adicionado</b> com sucesso ao diretório!',
            icon: 'mdi-check-circle',
            color: 'green',
          })
          this.closeDialog()
        } else {
          this.init()
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Desculpe não foi possível <b>adicionar</b> o arquivo ao diretório!',
            icon: 'mdi-close-circle',
            color: 'red',
          })
        }
      } catch (Error) {
        console.log('TCL: saveFile -> Error', Error)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    //alterando aqui estou
    // async addFilesOnDirectory(item) {
      
    //   try {
    //     this.$store.commit('user/UPDATE_LOADING', true)
    //     const formData = new FormData()
    //     formData.append('localFile', item.file)
    //     const routedEntity = await this.$getItem('routedEntity'),
    //       actionId = this.actionsMap.get('supportResourceCreate').id,
    //       ret = await SupportResource.addFilesOnFolder(
    //         routedEntity.id,
    //         actionId,
    //         item.parentId,
    //         item.child.files,
    //         item.files.name,
            
    //         formData
    //       )
    //     console.log('addFileOnDirectory ->  ret ', ret)
    //     if (ret.success) {
    //       this.init()
    //       this.dialog = false
    //       this.daddy = {}
    //       this.$store.commit('user/UPDATE_LOADING', true)
    //       this.$store.commit('user/UPDATE_ALERT', {
    //         status: true,
    //         message: 'Arquivo <b>adicionado</b> com sucesso ao diretório!',
    //         icon: 'mdi-check-circle',
    //         color: 'green',
    //       })
    //       this.closeDialog()
    //     } else {
    //       this.init()
    //       this.$store.commit('user/UPDATE_LOADING', false)
    //       this.$store.commit('user/UPDATE_ALERT', {
    //         status: true,
    //         message: 'Desculpe não foi possível <b>adicionar</b> o arquivo ao diretório!',
    //         icon: 'mdi-close-circle',
    //         color: 'red',
    //       })
    //     }
    //   } catch (Error) {
    //     console.log('TCL: saveFile -> Error', Error)
    //   } finally {
    //     this.$store.commit('user/UPDATE_LOADING', false)
    //   }
    // },


    async saveFolder(item) {
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        const routedEntity = await this.$getItem('routedEntity'),
          actionId = this.actionsMap.get('supportResourceCreate').id,
          ret = await SupportResource.createFolder(routedEntity.id, actionId, {
            name: item.name,
            folder: {
              name: item.name,
            },
          })
        this.init()
        this.dialog = false

        if (ret.success) {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: `A pasta <b>${ret.data[0].name}</b> foi <b>criada</b> com sucesso!`,
            icon: 'mdi-check-circle',
            color: 'green',
          })
        } else {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Erro! Não foi possível <b>criar</b> a pasta.',
            icon: 'mdi-close-circle',
            color: 'red',
          })
        }
      } catch (e) {
        console.error('TCL: saveFolder -> e', e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },
    async saveLink(item) {
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        const routedEntity = await this.$getItem('routedEntity'),
          actionId = this.actionsMap.get('supportResourceCreate').id,
          ret = await SupportResource.addExternalLink(routedEntity.id, actionId, {
            name: item.name,
            externalLink: {
              name: item.name,
              link: item.link,
            },
          })
        this.init()
        this.closeDialog()

        if (ret.success) {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: `O link externo <b>${ret.data[0].name}</b> foi <b>criado</b> com sucesso!`,
            icon: 'mdi-check-circle',
            color: 'green',
          })

        } else {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Erro! Não foi possível <b>criar</b> o link externo.',
            icon: 'mdi-close-circle',
            color: 'red',
          })
        }
      } catch (e) {
        console.error('TCL: saveLink -> e', e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },
    async saveFromDrive(item) {
      console.log(item, 'IMPORTANDOOOOO')
      this.progressImportFromDrive = 0
      this.$store.commit('user/UPDATE_LOADING', true)
      this.importFromDriveLenght = item.length
      // watch this.progressImportFromDrive

      item.forEach(async (file) => {
        if (file.extension && !file.link) {
          await this.linkFileFromDrive(file)
        }
        if (!file.extension && !file.link) {
          await this.linkFolderFromDrive(file)
        }
        if (!file.extension && file.link) {
          await this.linkExternalLinkFromDrive(file)
        }
      })
    },

    async linkFolderFromDrive(item) {
      try {
        // this.$store.commit('user/UPDATE_LOADING', true)
        const routedEntity = await this.$getItem('routedEntity'),
          actionId = this.actionsMap.get('supportResourceCreate').id,
          ret = await SupportResource.linkFolderDrive(routedEntity.id, actionId, {
            name: item.name,
            folderId: item.id,
          })
      } catch (e) {
        console.error('TCL: saveFolderFromDrive -> e', e)
      } finally {
        this.progressImportFromDrive++

        // this.$store.commit('user/UPDATE_LOADING', false)
      }
    },
    async linkFileFromDrive(item) {
      try {
        // this.$store.commit('user/UPDATE_LOADING', true)
        const routedEntity = await this.$getItem('routedEntity'),
          actionId = this.actionsMap.get('supportResourceCreate').id,
          ret = await SupportResource.linkFileDrive(routedEntity.id, actionId, {
            name: item.name,
            fileId: item.id,
          })
      } catch (e) {
        console.error('TCL: saveFolderFromDrive -> e', e)
      } finally {
        this.progressImportFromDrive++

        // this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    async linkExternalLinkFromDrive(item) {
      try {
        // this.$store.commit('user/UPDATE_LOADING', true)
        const routedEntity = await this.$getItem('routedEntity'),
          actionId = this.actionsMap.get('supportResourceCreate').id,
          ret = await SupportResource.linkExternalLinkDrive(routedEntity.id, actionId, {
            name: item.name,
            linkId: item.id,
          })
      } catch (e) {
        console.error('TCL: saveFolderFromDrive -> e', e)
      } finally {
        this.progressImportFromDrive++

        // this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    openFolder(item) {
      if (this.openedFolders.length == 2) this.openedFolders = []
      this.openedFolders = item
      this.lastOpenedFolder = this.openedFolders[this.openedFolders.length - 1]
    },

    async download(item) {
      let id = item.id
      let fileId = item.file.id

      // pra quando tenta baixar arquivo dentro de uma pasta
      if (!fileId) {
        fileId = item.id
        id = this.lastOpenedFolder
      }

      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        const routedEntity = await this.$getItem('routedEntity')
        const entityId = routedEntity.id
        const actionsMap = this.$store.state.user.mappedActions
        const actionId = actionsMap.get('supportResourceDownload').id
        await SupportResource.downloadSupportResource(
          entityId,
          actionId,

          {
            id: id,
            fileId: fileId,
          },
          `${item.name}${item.file.extension}`
        )
      } catch (e) {
        console.log('download -> e', e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    async deleteItem() {
      this.alert.status = false
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        const routedEntity = await this.$getItem('routedEntity'),
          actionId = this.actionsMap.get('supportResourceDelete').id,
          ret = await SupportResource.deleteSupportResource(routedEntity.id, actionId, {
            id: this.itemToDelete.id,
          })
        if (ret.success) {
          this.init()
          let message
          console.log(this.itemToDelete, 'item para deletar')

          if (this.itemToDelete.folder)
            message = `A pasta <b>${this.itemToDelete.name}</b> foi <b>deletada</b> com sucesso!`
          else if (this.itemToDelete.externalLink)
            message = `O link <b>${this.itemToDelete.name}</b> foi <b>deletado</b> com sucesso!`
          else if (this.itemToDelete.extension || this.itemToDelete.file.extension)
            message = `O arquivo <b>${this.itemToDelete.name}${
              this.itemToDelete.extension
                ? this.itemToDelete.extension
                : this.itemToDelete.file.extension
            }</b> foi <b>deletado</b> com sucesso!`

          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: message,
            icon: 'mdi-check-circle',
            color: 'green',
          })
        } else {
          let message

          if (this.itemToDelete.folder)
            message = `Desculpe, não foi possível deletar a pasta <b>${this.itemToDelete.name}</b>.`
          else if (this.itemToDelete.externalLink)
            message = `Desculpe, não foi possível deletar o link <b>${this.itemToDelete.name}</b>.`
          else if (this.itemToDelete.extension || this.itemToDelete.file.extension)
            message = `Não foi possível deletar o arquivo <b>${this.itemToDelete.name}${this.itemToDelete.extension}</b>.`

          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: message,
            icon: 'mdi-close-circle',
            color: 'red',
          })
        }
      } catch (e) {
        console.error('TCL: saveLink -> e', e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    async updateFileName(item){
      // console.log("item.updateFileName: ",item.updateFileName,
      //       "item.fileId: ", item.fileId)
      try {
        const routedEntity = await this.$getItem('routedEntity')

        const entityId = routedEntity.id

        const actionId = this.actionsMap.get('supportResourceUpdate').id

        await SupportResource.updateFileName( entityId, actionId ,{
          oldName: item.oldName,
          name: item.updateFileName,
          fileId: item.fileId,
          supportResourceId: item.supportResourceId
        })

        this.init()

        this.$store.commit('user/UPDATE_LOADING', false)
        this.$store.commit('user/UPDATE_ALERT', {
          status: true,
            message: `<b>${item.oldName}</b> foi <b>atualizado</b> com sucesso!`,
            icon: 'mdi-check-circle',
            color: 'green',
          })

        return 
      } catch (error) {
        throw error   
      }
  },

    async editItem(item) {
      console.log('TCL: editItem -> item', item)
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let updateEdit = { name: '', initDate: '', endDate: '' }
        let updateItem = null

        if (this.folderToEdit && this.updateFolder) {
          updateItem = item.folder
          updateEdit.name = updateItem.name
          updateEdit.initDate = updateItem.initDate
          updateEdit.endDate = updateItem.endDate
        } else if (this.fileToEdit && this.updateFile) {
          updateItem = item.file
          updateEdit.name = updateItem.name
          updateEdit.initDate = updateItem.initDate
          updateEdit.endDate = updateItem.endDate
        } else {
          updateItem = item.externalLink
          updateEdit.name = updateItem.name
          updateEdit.initDate = updateItem.initDate
          updateEdit.endDate = updateItem.endDate
          updateEdit.externalLink = { name: updateItem.name, link: updateItem.link, id: updateItem.externalLink.id }
        }

        const routedEntity = await this.$getItem('routedEntity'),
          actionId = this.actionsMap.get('supportResourceUpdate').id,
          ret = await SupportResource.updateSupportResource(routedEntity.id, actionId, {
            id: updateItem.id,
            update: updateEdit,
          })
        this.init()

        if (ret.success) {
          console.log(item, 'item para editar')
          // msg de sucesso
          let message
          if (this.folderToEdit)
            message = `A pasta <b>${ret.data.name}</b> foi <b>modificada</b> com sucesso!`
          if (this.fileToEdit)
            message = `O arquivo <b>${ret.data.name}</b> foi <b>modificado</b> com sucesso!`
          if (this.linkToEdit)
            message = `O link externo <b>${ret.data.name}</b> foi <b>modificado</b> com sucesso!`

          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: message,
            icon: 'mdi-check-circle',
            color: 'green',
          })
        } else {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Erro! Não foi possível realizar a <b>modificação</b>.',
            icon: 'mdi-close-circle',
            color: 'red',
          })
        }
      } catch (e) {
        console.error(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
      this.closeDialog()
    },

    hasMethod(name) {
      return this.methods.has(name)
    },

    openLink(item) {
      window.open(item.externalLink.link, '_blank')
    },

    async clickToOpenFolder(item) {
      // algoritmo padrão
      if (item.id !== this.lastClickInTree) {
        this.temp.clear()
        this.generateSet(this.supportResource, item.id)
        const parentId = this.searchForParentId(item.id)
        if (parentId == null) {
          this.open = [item.id]
          //pasta na raiz do material de apoio
          await this.showFolderContent(item.id)
          if (!item.children) {
            this.$set(item, 'children', [])
          }
          item.children = this.tempChildren
        } else {
          await this.showFolderContent(parentId.id, item.id)

          if (!item.children) {
            this.$set(item, 'children', [])
          }
          item.children = this.tempChildren
          this.open.push(item.id)
        }
      }
      this.lastClickInTree = item.id
      this.open.push(item.id)
    },

    generateSet(data, id) {
      for (let i = 0; i < data.length; i++) {
        this.temp.add({
          id: data[i].id,
          name: data[i].name,
          children: data[i].children ? [...data[i].children] : [],
        })

        if (data[i].children) this.generateSet(data[i].children, id)
      }
    },

    searchForParentId(id) {
      let array = [...this.temp]
      for (let i = 0; i < array.length; i++) {
        if (array[i].children.length > 0) {
          for (let x = 0; x < array[i].children.length; x++) {
            if (array[i].children[x].id == id) {
              return { name: array[i].name, id: array[i].id }
            }
          }
        }
      }
      return null
    },

    async showFolderContent(supportResourceId, folderId) {
      let folderItems
      const routedEntity = await this.$getItem('routedEntity')
      let id = routedEntity.id
      try {
        this.$store.commit('user/UPDATE_LOADING', true)

        let ret = await SupportResource.readFolderInfo(supportResourceId, folderId)

        if (ret.success) {
          // necessário quando nao manda folderId, arrumar dados vindo do back para o padrão
          // this.init()
          if (!folderId) {
            ret.data.child = ret.data.folder.child
          }

          folderItems = ret.data
          folderItems.children = []
          if (!folderItems.child) folderItems.child = { folders: [] }

          if (folderItems.child.folders) {
            folderItems.child.folders.forEach((folder) => {
              folderItems.children.push({ ...folder, icon: this.icons['folder'], folder: [] })
            })
          }
          if (folderItems.child.files) {
            folderItems.child.files.forEach((file) => {
              folderItems.children.push({
                ...file,
                icon: this.icons[file.extension],
                file: { extension: file.extension },
              })
            })
          }
          if (folderItems.child.externalLinks) {
            folderItems.child.externalLinks.forEach((link) => {
              folderItems.children.push({
                ...link,
                icon: this.icons.link,
                link: link.link,
                externalLink: link,
              })
            })
          }
          folderItems.child = {}
        }
      } catch (e) {
        console.error('TCL: init -> e', e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
      if (folderItems.children.length == 0)
        folderItems.children = [{ name: 'O diretório não contém arquivos.', empty: [] }]
      this.tempChildren = folderItems.children // salva children temp na variavel global
    },

    // atualizar na Árvore

    async refreshOpennedFolder(item) {
      this.lastClickInTree = ''
      // algoritmo padrão
      this.temp.clear()
      this.generateSet(this.supportResource, item.id)
      const parentId = this.searchForParentId(item.id)
      if (parentId == null) {
        //pasta na raiz do material de apoio
        await this.showFolderContent(item.id)
        this.filterToRefresh(this.supportResource, item.id)
        this.open = [item.id]
      } else {
        await this.showFolderContent(parentId.id, item.id)
        this.filterToRefresh(this.supportResource, item.id)
        this.open.push(item.id)
      }
    },

    filterToRefresh(data, id) {
      var r = data.filter((item) => {
        if (item.children) item.children = this.filterToRefresh(item.children, id)
        if (item.id == id) {
          if (!item.children) {
            this.$set(item, 'children', [])
          }
          item.children = this.tempChildren
        }
        return item.id
      })
      return r
    },
  },
}
</script>
<style lang="css">
.noResources {
  font-size: 1rem;
  text-align: center;
  min-height: 100px;
}
.noResources > b {
  padding-left: 4px;
  padding-right: 4px;
}

.navSupportResourceOption > .v-btn:hover {
  background: #e8e8e8 !important;
  color: #2a0845 !important;
}
</style>
